#!/bin/bash
# ------------------------------------------------------------------------------------------
# Eisfair old Libraries - Deinstallieren von nicht mehr benötigten Libraries auf Eisfair.
# Version vom: 17.02.2025
# Copyright (C) 2025 Detlef Paschke
# Download unter: https://schabau.eu/eisfair_old_libraries.html
#
# Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General
# Public License, wie von der Free Software Foundation veröffentlicht, weitergeben und/oder
# modifizieren, entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren
# Version.
#
# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es Ihnen von Nutzen
# sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE
# oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General
# Public License.
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm
# erhalten haben. Falls nicht, siehe <http://www.gnu.org/licenses/>.
# ------------------------------------------------------------------------------------------
# set -x
while getopts ":hH" option; do
    case $option in
        [hH])
            echo "Dieses Script sucht und deinstalliert Libraries, die von Eisman als nicht"
            echo "mehr benötigt identifiziert werden. Das Script sollte mehrfach ausgeführt"
            echo "werden, da es bei den Libraries auch untereinander Abhängigkeiten geben"
            echo "kann. Libraries die nicht über Eisman installiert wurden, können nicht"
            echo "zuverlässig als nicht mehr benötigt identifiziert werden."
            echo "JEDER ANWENDER MUSS SELBST BEOBACHTEN, WAS DEINSTALLIERT WERDEN SOLL!"
            exit 0
            ;;
        *)
            echo -e "Ungültige Option!\nStarten Sie ohne Option oder mit -h für Hilfe."
            exit 0
            ;;
    esac
done
echo -e "\033[31m"Default werden alle installierten Libs überprüft. Das kann einige Zeit dauern."\033[0m"
while true; do
    read -r -p "$(echo -e "\033[32m"Die Suche auf bestimmte Versionen beschränken? [2.0 3.0 3.2.1]"\033[0m") " var
    if [[ $var =~ ^[0-9]\.?[0-9]?+ ]] || [[ $var = '' ]]; then
        break
    fi
    echo -e "\033[31m"Ungültige Eingabe"\033[0m"
done
echo -e "\033[31m"Default muss für jede Lib die Deinstallation bestätigt werden. \(Interaktiv\)"\033[0m"
while true; do
    read -r -n1 -s -p "$(echo -e "\033[32m"[I]nteraktiv, [A]utomatisch, nur [O]utput oder E[x]it?"\033[0m") " REPLY
    case $REPLY in
        [iI] | "")
            echo -e "Interaktiv\n"
            break
            ;;
        [aA])
            echo -e "Automatisch\n"
            OPT="--auto"
            break
            ;;
        [oO])
            echo -e "Output\n"
            OPT="--info"
            break
            ;;
        [xX])
            echo -e "Exit\n"
            exit 0
            ;;
        *)
            echo -e "\033[31m"Ungültige Eingabe"\033[0m"
            ;;
    esac
done
installedlibs=$(eisman query --format "{N}={V}" --installed "lib*" | grep "=$var" | cut -d "=" -f1)
for i in ${installedlibs}; do
    if [ "$(timeout 2s eisman usage "${i}" | wc -l)" -eq 1 ]; then
        if ! eisman query --quiet "${i}"; then
            OUT="(Lib ist nicht mehr verfügbar.)"
        fi
        echo -e "\033[31m""${i}" wird nicht mehr benötigt "$OUT""\033[0m"
        eisman uninstall "$OPT" "${i}"
    fi
done
